// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef Factory_h_included
#include "Factory.h"
#endif

#ifndef ScaleConfiguration_h_included
#include "ScaleConfiguration.h"
#endif

#ifndef myassert_h_included
#include "myassert.h"
#endif

#ifndef Action_h_included
#include "Action.h"
#endif

#ifndef FactoryTable_h_included
#include "FactoryTable.h"
#endif

#ifndef FString_h_included
#include "FString.h"
#endif

#ifndef TopLevel_h_included
#include "TopLevel.h"
#endif

#ifndef Canvas_h_included
#include "Canvas.h"
#endif

namespace {
  class BumpScale
    : public Factory
  {
  public:
    BumpScale ()
      : Factory ("BumpScale")
    {}
    SP<Configuration> defaultConfiguration () const {
      return NEW (ScaleConfiguration ());
    }
    SP<Configurable> makeIt (const SP<Configuration> c) const {
      SP<ScaleConfiguration> conf =
	dynamic_cast <ScaleConfiguration *> (&*c);
      assert (conf);
      FFloat scale = conf->getScale ();
      SP<Canvas> vo = conf->getTopLevel()->getCanvas();
      // FIXME scale around the (x,y) coordinates of the mouse.
      // This requires being able to do matrix inversion to infer world
      // coordinates from mouse coordinates.  I can do that now, but not worth
      // fixing for this release.
      vo->setScale (vo->getScale () * scale);
      // No errors possible.
      return NEW (Action ());
    }
  };
  const bool useless =
  (FactoryTable::store ("Action", NEW (BumpScale ())),
   true);
} // namespace
