// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef Geometry_h_included
#define Geometry_h_included

#ifndef FFloat_h_included
#include "FFloat.h"
#endif

struct Geometry {
  // We have a triangle in two dimensions.  The points are the origin O
  // at (0,0), point A at (sOA, 0), and point B.  The sides are sOA,
  // sOB, sAB.  Return the coordinates of B. 
  static void findTrianglePoint (FFloat sOA, FFloat sOB, FFloat sAB,
				 FFloat & Bx, FFloat & By);
  // Take some squares as arguments, so we don't create the need for
  // unnecessary square roots.
  static void findTrianglePoint (FFloat sOAsOA, FFloat sOBsOB, FFloat sABsAB,
				 FFloat sOA,
				 FFloat & Bx, FFloat & By);
};

#endif
