#ifndef SceneSorter_h_included
#define SceneSorter_h_included

// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 N Fernwood Circle
// Sunnyvale, CA 94085-3059
//
#ifndef Dynavec_h_included
#include "Dynavec.h"
#endif

#ifndef Refcount_h_included
#include "Refcount.h"
#endif

class SceneGraph;
class SceneSorter : public virtual Refcount {
public:
  // Given a SceneGraph, fill in the permutation vector to say where each
  // existing PhysicsObject should go to.  Also set newLength to one more than
  // the largest value in the permutation.  The indices into permutation
  // are old object numbers and the values are new object numbers.
  // PhysicsObject's in the SceneGraph can be null if anything has been
  // deleted, and in that case garbageCollectSort must put -1 in that slot of
  // permutation.  (The requirement for -1's comes from
  // LinkManager.updateAfterGC.)
  virtual void garbageCollectSort (const SceneGraph *sg,
                                   Dynavec<int> &permutation,
                                   int &newLength) = 0;
};

#endif
