// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef TestSceneConfiguration_h_included
#define TestSceneConfiguration_h_included

#ifndef FFloat_h_included
#include "FFloat.h"
#endif

#ifndef SP_h_included
#include "SP.h"
#endif

#ifndef SceneLoaderConfiguration_h_included
#include "SceneLoaderConfiguration.h"
#endif

class RecursiveSlotValue;
class PhysicsObject;
class SceneGraph;
class Factory;
class Vec3;

class TestSceneConfiguration : public SceneLoaderConfiguration {
public:
  TestSceneConfiguration ();
  SP<PhysicsObject> makeIt () const;
  int getCubeSize () const;
  void setCubeSize (int s);
  FFloat getCubeSpace () const;
  void setCubeSpace (FFloat s);
  void setRecursiveSlotValue (SP<RecursiveSlotValue> r);
  SP<RecursiveSlotValue> getRecursiveSlotValue ();
  SP<const RecursiveSlotValue> getRecursiveSlotValue () const;

  SP<Configuration> copy () const;
  bool hasTheSameTypeAs (const Configuration *c) const;
  FString unParse () const;
};
 
#endif
