// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef TopConfiguration_h_included
#define TopConfiguration_h_included

#ifndef Configuration_h_included
#include "Configuration.h"
#endif

#ifndef FFloat_h_included
#include "FFloat.h"
#endif

class RecursiveSlotValue;
class ConstantRecursiveSlotValue;
class FString;

// A Top is the entire application.  This differs from a TopLevel, which is a
// specific interaction style and window system.  Note that one of the
// configuration parameters below is the TopLevel, and that can be changed like
// any other.
class TopConfiguration
  : public Configuration
{
 public:
  TopConfiguration (const FString &topLevelClass);
  RecursiveSlotValue *getSceneGraphSlot ();
  RecursiveSlotValue *getSceneLoaderSlot ();
  void setSceneLoaderSlot (RecursiveSlotValue *rsv);
  RecursiveSlotValue *getTopLevelSlot ();
  int getStepsPerFrame () const;
  FFloat getTimePerStep () const;
  // How to integrate.  RungeKutta, for instance.
  RecursiveSlotValue *getIntegrator ();
  const RecursiveSlotValue *getIntegrator () const;

  SP<Configuration> copy () const;
  bool hasTheSameTypeAs(const Configuration *c) const;
};
#endif
