// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef AnyMouseTrackballConfiguration_h_included
#define AnyMouseTrackballConfiguration_h_included

#ifndef OuterTransformConfiguration_h_included
#include "OuterTransformConfiguration.h"
#endif

#ifndef SP_h_included
#include "SP.h"
#endif

#ifndef FFloat_h_included
#include "FFloat.h"
#endif

class Configuration;
class AnyMouseTrackballConfiguration
  : public OuterTransformConfiguration
{
  // Where on the screen the mouse was last observed.
  int m_x;
  int m_y;
public:
  AnyMouseTrackballConfiguration ();
  // You can configure the radius of the virtual trackball.  Smaller trackballs
  // rotate things faster.
  FFloat getRadius () const; 
  void setRadius (FFloat r);
  // Next four are redundant with AnyMouseXYMoveConfiguration.  Bummer.  Only
  // twice, and not much code, so I'm not making a subclass yet.
  int getX () const;
  int getY () const;
  void setX (int x);
  void setY (int y);
  SP<Configuration> copy () const  ;
  bool hasTheSameTypeAs (const Configuration *c) const;
};

#endif
