// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef OuterTransformConfiguration_h_included
#include "OuterTransformConfiguration.h"
#endif

#ifndef TransformConfiguration_h_included
#include "TransformConfiguration.h"
#endif

#ifndef MemoryUtil_h_included
#include "MemoryUtil.h"
#endif

#ifndef FString_h_included
#include "FString.h"
#endif

#ifndef RecursiveSlotValue_h_included
#include "RecursiveSlotValue.h"
#endif

namespace {
  FString subCommandName () {
    return "TransformCommand to perform";
  }
}

OuterTransformConfiguration::OuterTransformConfiguration () {
  initializeSlot (subCommandName (),
		  NEW (RecursiveSlotValue ("TransformAction", "DoNothing")));
}

bool OuterTransformConfiguration::hasTheSameTypeAs
(const Configuration *c) const
{
  return 0 != dynamic_cast <const OuterTransformConfiguration *> (c);
}

SP<Configuration> OuterTransformConfiguration::copy () const {
  return NEW (OuterTransformConfiguration (*this));
}

SP<RecursiveSlotValue>
OuterTransformConfiguration::getTransformAction ()
{
  return RecursiveSlotValue::getSlotValue (this, subCommandName ());
}

SP<const RecursiveSlotValue>
OuterTransformConfiguration::getTransformAction ()
const
{
  return RecursiveSlotValue::getSlotValue (this, subCommandName ());
}

void OuterTransformConfiguration::setTransformAction
(SP<RecursiveSlotValue> ts)
{
  RecursiveSlotValue::setSlotValue (this, subCommandName (), ts);
}
