// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 N Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef FFloat_h_included
#define FFloat_h_included

// brennerc requires setting DOUBLE_PRECISION.  We ought to be able to compile
// plugins like Hi.cpp with a minimum of fuss with special compiler options, so
// we always need to be double precision.  This needs to be fixed; we need to
// take a prinicpled on where in the API we have doubles and where we have
// floats, and then be consistent with that.  Tim Freeman 14 Aug 2001.
#ifndef DOUBLE_PRECISION
  #define DOUBLE_PRECISION yes
#endif

// Compilation with brennerc wants to have -DFloat=something.
#ifndef FFloat
#ifdef DOUBLE_PRECISION
typedef double FFloat;
#else
typedef float FFloat;
#endif
#endif
#endif
